package org.openjdk.gcbench.sieve;

import org.openjdk.jmh.annotations.*;
import org.openjdk.jmh.infra.Blackhole;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.TimeUnit;

@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@State(Scope.Thread)
@Threads(Threads.MAX)
public class Objects {

    List<Object> retained;

    @Param({"1000"})
    int size;

    @Setup
    public void setup() {
        retained = new ArrayList<>();
    }

    @Benchmark
    public void test(Blackhole bh) {
        if (ThreadLocalRandom.current().nextInt(size) == 0) {
            retained.add(new Object());
            if (retained.size() > 1_000_000) {
                retained.clear();
            }
        } else {
            bh.consume(new Object());
        }
    }

}
